﻿using System;
using System.Data;
using System.Drawing;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            ultraGrid1.DataSource = GenerateDataSet();
        }

        public DataTable GenerateDataSet()
        {
            DataTable table = new DataTable("Treatment Fluu");
            table.Columns.Add("Method", typeof(string));
            table.Columns.Add("RichText", typeof(string));
            table.Rows.Add("L<sub>4<sub>(2<sup>3<sup>)", "L<sub>5<sub>(6<sup>7<sup>)");

            return table;
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns["Method"].Width = 300;

            e.Layout.Bands[0].Columns["RichText"].Editor = new RichTextBoxEditor();
        }

        private void ultraGrid1_ClickCell(object sender, ClickCellEventArgs e)
        {
            this.richTextBox1.Clear();

            string[] method = e.Cell.Value.ToString().Split(
                new string[] { "<sub>" }, StringSplitOptions.None);

            this.richTextBox1.SelectedText = method[0];

            this.richTextBox1.SelectionFont = new Font("Malgun Gothic", 7);
            this.richTextBox1.SelectedText = method[1];

            string[] levelVariablesCount = method[2].Split(
                new string[] { "<sup>" }, StringSplitOptions.None);
            int nCount = levelVariablesCount.Length;

            for (int i = 0; i < nCount; i++)
            {
                if (0 == i % 2)
                {
                    this.richTextBox1.SelectionFont = new Font("Malgun Gothic", 10);
                    this.richTextBox1.SelectionCharOffset = 0;
                    this.richTextBox1.SelectedText = levelVariablesCount[i];
                }
                else
                {
                    this.richTextBox1.SelectionFont = new Font("Malgun Gothic", 7);
                    this.richTextBox1.SelectionCharOffset = 3;
                    this.richTextBox1.SelectedText = levelVariablesCount[i];
                }
            }
        }
    }
}