﻿using System;
using System.Drawing;
using System.Windows.Forms;
using Infragistics.Win;

namespace WindowsFormsApplication1
{
    public class RichTextBoxEditor : ControlContainerEditor
    {
        private RichTextBox richTextBox;

        /// <summary>
        /// Overriden to get or set the value directly on the UltraGauge automatically.
        /// </summary>
        protected override object RendererValue
        {
            get { return this.richTextBox.Text; }
            set
            {
                string[] method = value.ToString().Split(
                    new string[] { "<sub>" }, StringSplitOptions.None);

                this.richTextBox.SelectedText = method[0];

                this.richTextBox.SelectionFont = new Font("Malgun Gothic", 7);
                this.richTextBox.SelectedText = method[1];

                string[] levelVariablesCount = method[2].Split(
                    new string[] { "<sup>" }, StringSplitOptions.None);
                int nCount = levelVariablesCount.Length;

                for (int i = 0; i < nCount; i++)
                {
                    if (0 == i % 2)
                    {
                        this.richTextBox.SelectionFont = new Font("Malgun Gothic", 10);
                        this.richTextBox.SelectionCharOffset = 0;
                        this.richTextBox.SelectedText = levelVariablesCount[i];
                    }
                    else
                    {
                        this.richTextBox.SelectionFont = new Font("Malgun Gothic", 7);
                        this.richTextBox.SelectionCharOffset = 3;
                        this.richTextBox.SelectedText = levelVariablesCount[i];
                    }
                }
            }
        }

        public RichTextBoxEditor()
        {
            this.richTextBox = new RichTextBox();
            this.richTextBox.BorderStyle = BorderStyle.None;
            this.richTextBox.ScrollBars = RichTextBoxScrollBars.None;
            this.RenderingControl = this.richTextBox;
        }
    }
}